<?php
/* $Fuller: myprograms/htbm/web/php/admin_bmark.php,v 1.10 2002/10/06 12:19:15 fullermd Exp $ */

/* Admin stuff for bookmarks */

/* Print out a form for new/edit bookmark */
function print_bmark_form($bminfo)
{
	global $db;
	global $new;
	global $edit;

	$mark_id = $bminfo['mark_id'];
	$url = $bminfo['url'];
	$title = $bminfo['title'];
	$comment = $bminfo['comment'];
	$parents = $bminfo['parents'];

	if($mark_id>0)
	{ print("<h1>Bookmark number $mark_id</h1>\n"); }

	/* Mark info */
	/* XXX This should be prettified.  A lot. */
	?>
<ul>
<li>
URL:
<input type="text" size="70" name="url" value="<?php echo("$url")?>" />
</li>
<li>
Title:
<input type="text" size="70" name="title" value="<?php echo("$title")?>" />
</li>
<li>
Comment:
<br />
<textarea name="comment" rows="10" cols="80">
<?php echo("$comment")?>
</textarea>
</li>
<?php
	/* Recurse through parents */
	$i=0;
	$categories = build_categories();
	foreach($parents as $dummy => $thisparent)
	{
		?>
<li>
Category:
<select name="parent[<?php echo("$i")?>]">
<?php
		/* Disable */
		if($new!=1)
		{
			print("<option value=\"-1\">");
			print("(none)</option>\n");
		}

		/* Special-case the top-level */
		if($thisparent==0)
		{ $seld = " selected=\"selected\""; }
		else
		{ $seld = ""; }

		/* Top level */
		print("<option value=\"0\"$seld>");
		print("Bookmarks</option>\n");

		/* Print the rest */
		select_listkids(0,$thisparent,$categories);

		/* Done categories */
		?>
</select>
<input type="hidden" name="old_parent[<?php echo("$i")?>]"
  value="<?php echo("$thisparent")?>" />
</li>
<?php
		$i++;
	}

	/* If we're in edit mode, allow adding another */
	if($edit==1)
	{
		?>
<li>
Category:
<select name="parent[<?php echo("$i")?>]">
<?php
		print("<option value=\"-1\" selected=\"selected\">");
		print("(none)</option>\n");

		/* Top level */
		print("<option value=\"0\">");
		print("Bookmarks</option>\n");

		/* Print the rest */
		select_listkids(0,-1,$categories);

		/* Done categories */
		?>
</select>
<input type="hidden" name="old_parent[<?php echo("$i")?>]"
  value="-1" />
</li>
<?php
	}
	?>
</ul>
<?php
	/* Fin */
}

/* List kids of a given cid in <select> output format */
/*
 * XXX
 * This is stolen pretty much verbatim from listkids.php.  We really
 * should find a way of merging as much as possible of these to make
 * future maintenance easier.
 */
function select_listkids($cid,$whichsel,$categories)
{
	$thekids = $categories[$cid]['children'];
	if(!$thekids)
	{ return; }

	foreach($thekids as $dummy => $thevalue)
	{
		d_print("<!-- Starting on kid $thevalue -->\n");
		if($thevalue==0)
		{ continue; }

		/* Find our distance from the 'root' */
		if($thevalue!=0)
		{
			$tmpcat = $categories[$thevalue];
			$leader = "&nbsp;";
			while($tmpcat['parent'] != 0)
			{
				$leader .= "&nbsp;";
				$mypar = $tmpcat['parent'];
				$tmpcat = $categories[$mypar];
			}
		}

		/* Should we be selected? */
		if($thevalue==$whichsel)
		{ $seld = " selected=\"selected\""; }
		else
		{ $seld = ""; }

		/* Print ourselves out */
		$myname = $categories[$thevalue]['name'];
		print("<option value=\"$thevalue\"$seld>$leader$myname</option>\n");

		/* Do we have children? */
		$havekids = $categories[$thevalue]['has_children'];

		if($havekids)
		{
			select_listkids($thevalue,$whichsel,$categories);
		}
	}
}
